#include <Keypad.h> // the library for the 4x4 keypad
#include <LiquidCrystal_I2C.h> // the library for the i2c 1602 lcd
#include <Servo.h> // the library to control the servo motor




Servo servo1;
Servo servo2;
Servo servo3;
Servo servo4;


LiquidCrystal_I2C lcd(0x3F,20,4); // gets the lcd 


#define Password_Length 5 // the length of the password, if the password is 4 digits long set this to 5
int StopPosition = 90; // position of the servo
int RotatePosition = 135; // position of the servo


char Particular[Password_Length]; // the password length 

char Specific1[Password_Length] = "1111"; // the option 1
char Specific2[Password_Length] = "2222"; // the option 2
char Specific3[Password_Length] = "3333"; // the option 3
char Specific4[Password_Length] = "4444"; // the option 4

byte Particular_Count = 0, Specific_Count = 0; // counts the amount of digits and and checks to see if the password is correct
char Key; 

const byte ROWS = 4; // the amount of rows on the keypad
const byte COLS = 4; // the amount of columns on the keypad
char keys[ROWS][COLS] = { // sets the rowns and columns

  
  // sets the keypad digits
  {'1','2','3','A'}, 

  {'4','5','6','B'},

  {'7','8','9','C'},

  {'*','0','#','D'}
};
bool SmartDoor = true; // the servo 
// the pins to plug the keypad into

byte rowPins[ROWS] = {7, 6, 5, 4};
byte colPins[COLS] = {3, 2, 1, 0};

Keypad myKeypad( makeKeymap(keys), rowPins, colPins, ROWS, COLS); // gets the data from the keypad

int z=0;

char OPTION1CODE[4] = {'1','1','1','1'}; // selection option 1
char OPTION2CODE[4] = {'2','2','2','2'}; // selection option 2
char OPTION3CODE[4] = {'3','3','3','3'}; // selection option 3
char OPTION4CODE[4] = {'4','4','4','4'}; // selection option 4

char attempt[2] = {0,0};


// locked charcater
byte Locked[8] = { 
  111111,
  222222,
  333333,
  444444,
};
// open character
byte Opened[8] = {
  111111,
  222222,
  333333,
  444444,
};

int correct1=0;
int correct2=0;
int correct3=0;
int correct4=0;

void setup()
{
  servo1.attach(8); // attaches the servo to pin 10
  servo2.attach(9); // attaches the servo to pin 10
  servo3.attach(10); // attaches the servo to pin 10
  servo4.attach(11); // attaches the servo to pin 10
  
  ServoClose(); // closes the servo when you say this function
  
  lcd.init(); // initializes the lcd 
  lcd.backlight(); // turns on the backlight
  lcd.setCursor(0,0); // sets the cursor on the lcd
  lcd.setCursor(0,1); // sets the cursor on the lcd
  lcd.print("welcome !!!"); // prints text
  delay(1000); // waits 4 seconds
  lcd.clear(); // clears the lcd diplay

}


void clearData() // clears the data
{
  while (Particular_Count != 0) // counts the digits pressed
  {
    Particular[Particular_Count--] = 0; // counts how many digits
  }
  return; // returns the data
}




void Servo1Open() // opens the servo
{
  
    servo1.write(RotatePosition); // moves to the postion
    delay(2000); // waits 15 milliseconds
  
}

void Servo2Open() // opens the servo
{
  
    servo2.write(RotatePosition); // moves to the postion
    delay(2000); // waits 15 milliseconds
  
}

void Servo3Open() // opens the servo
{
 
    servo3.write(RotatePosition); // moves to the postion
    delay(2000); // waits 15 milliseconds
  
}

void Servo4Open() // opens the servo
{
  
    servo4.write(RotatePosition); // moves to the postion
    delay(2000); // waits 15 milliseconds
  
}








void ServoClose() // closes the servo
{
 
    servo1.write(StopPosition); // moves to the position
    servo2.write(StopPosition); // moves to the position
    servo3.write(StopPosition); // moves to the position
    servo4.write(StopPosition); // moves to the position
    
    delay(15); // waits 15 milliseconds
  
}

void checkKEY()
{
   

   for (int i = 0; i <= 4 ; i++ )
   {
      if (attempt[i]==OPTION1CODE[i])
      {
         correct1++;
      }
   }
   if (correct1==4)
   {
     Servo1Open();
      lcd.clear();
      lcd.setCursor(0,1); // sets the cursor on the lcd
      lcd.print("THANK YOU");
   }
   ////
    for ( int x = 0; x <= 4 ; x++ )
   {
      if (attempt[x]==OPTION1CODE[x])
      {
         correct2++;
      }
   }
   if (correct2==4)
   {
      Servo2Open();
      lcd.clear();
      lcd.setCursor(0,1); // sets the cursor on the lcd
      lcd.print("THANK YOU");
   }
   ////
     for ( int y = 0; y <= 4 ; y++ )
   {
      if (attempt[y]==OPTION1CODE[y])
      {
         correct3++;
      lcd.clear();
      lcd.setCursor(0,1); // sets the cursor on the lcd
      lcd.print("THANK YOU");
      }
   }
   if (correct3==4)
   {
     Servo3Open();
   }
   ///

     for ( int w = 0; w <= 4 ; w++ )
   {
      if (attempt[w]==OPTION1CODE[w])
      {
         correct4++;
      lcd.clear();
      lcd.setCursor(0,1); // sets the cursor on the lcd
      lcd.print("THANK YOU");
      }
   }
   if (correct4==4)
   {
    
             Servo4Open();
      lcd.clear();
      lcd.setCursor(0,1); // sets the cursor on the lcd
      lcd.print("THANK YOU");
   }

   
   else
   {
      incorrectCODE();
   }
   
   for (int zz=0; zz <= 5; zz++) // clear previous key input
   {
      attempt[zz]=0;
      correct1=0;
      correct2=0;
      correct3=0;
      correct4=0;
   }
   
}

void incorrectCODE() // do this if an incorrect KEY is entered
{
   Serial.println("Invalid selection");
   delay(2000);
   Serial.println("Enter your selection and press #:");
}

void readKeypad()
{
   char key = myKeypad.getKey();
   if (key != NO_KEY)
   {
      switch(key)
      {
      case '*':
         Particular_Count=0;
         break;
      case '#':
         delay(100); // added debounce
        checkKEY();
         break;
      default:
         attempt[z]=key;
         Particular_Count++;
      }
   }
}

void loop() // function declarations
{
  lcd.setCursor(1,0); // sets the cursor on the lcd
  lcd.print("INPUT NUMBER"); // prints the text
  readKeypad();
  clearData(); // clears the data
}
